
local V_SOLITAIRE = 0.31

local Sprite = Image.load("sprite.png", RAM)
local Titre = Image.load("titre.jpg", RAM)
local coulBlack = Color.new(0,0,0)
local coulRed = Color.new(28,2,2)
local coulGreen = Color.new(5, 28, 5)
local coulDGreen = Color.new(5, 22, 5)
local carte = {}
local ltalon = {}
local lpioche = {}
local menu = false
local l = {}
l[1] = {}
l[2] = {}
l[3] = {}
l[4] = {}
l[5] = {}
l[6] = {}
l[7] = {}
local tour = {}
tour[1] = {}
tour[2] = {}
tour[3] = {}
tour[4] = {}
tour[1].val = 0
tour[2].val = 0
tour[3].val = 0
tour[4].val = 0
local pileSel = {}
local oldx = 0
local oldy = 0
local i=0
local quit = false
local ok = false
local pause = false

local tapisBas = Canvas.new()
Canvas.add(tapisBas, Canvas.newFillRect(0,0, 256, 192, coulGreen))
Canvas.add(tapisBas, Canvas.newFillRect( 1,2, 31, 52, coulDGreen))
Canvas.add(tapisBas, Canvas.newFillRect(1,60, 31, 110, coulDGreen))
Canvas.add(tapisBas, Canvas.newFillRect(33,2, 63, 52, coulDGreen))
Canvas.add(tapisBas, Canvas.newFillRect(65,2, 95, 52, coulDGreen))
Canvas.add(tapisBas, Canvas.newFillRect(97,2, 127, 52, coulDGreen))
Canvas.add(tapisBas, Canvas.newFillRect(129,2, 159, 52, coulDGreen))
Canvas.add(tapisBas, Canvas.newFillRect(161,2, 191, 52, coulDGreen))
Canvas.add(tapisBas, Canvas.newFillRect(193,2, 223, 52, coulDGreen))
Canvas.add(tapisBas, Canvas.newFillRect(225,2, 255, 52, coulDGreen))
Canvas.add(tapisBas, Canvas.newImage(1,170,Sprite,68,0,20,20))

local tapisHaut = Canvas.new()
Canvas.add(tapisHaut, Canvas.newImage(0,0,Titre))
Canvas.add(tapisHaut, Canvas.newFillRect(129,141, 159, 191, coulDGreen))
Canvas.add(tapisHaut, Canvas.newFillRect(161,141, 191, 191, coulDGreen))
Canvas.add(tapisHaut, Canvas.newFillRect(193,141, 223, 191, coulDGreen))
Canvas.add(tapisHaut, Canvas.newFillRect(225,141, 255, 191, coulDGreen))

local tapisJeux = Canvas.new()
local tapisTour = Canvas.new()


local addCarte = function(num)
	Canvas.add(tapisJeux, carte[num].ImCanvas)
	Canvas.add(tapisJeux, carte[num].ImCanDes1)
	Canvas.add(tapisJeux, carte[num].ImCanTxt1)
	Canvas.add(tapisJeux, carte[num].ImCanDes2)
	Canvas.add(tapisJeux, carte[num].ImCanTxt2)
end

local createCarte = function()
	local i , j, k, l, m, coul, n
	for i=1, 4 do
		for j=1, 13 do
			k = j+((i-1)*13)
			carte[k] = {}
			carte[k].val = j
			carte[k].coul = i -- 1: Trefle, 2: Coeur, 3: Pique, 4: Carreau
			carte[k].posx = 1
			carte[k].posy = 2
			carte[k].retour = false
			carte[k].ImCanvas = Canvas.newImage(carte[k].posx, carte[k].posy, Sprite, 8, 0, 30, 50)
			l = carte[k].val
			if(l== 11) then l = "V"
			elseif(l== 12) then l = "D"
			elseif(l== 13) then l = "R" end
			m = i*8
			if((i%2)==1) then coul = coulBlack
			else coul = coulRed end
			if(l == 10) then n = 14 else n = 20 end
			carte[k].ImCanDes1 = Canvas.newImage(carte[k].posx+3, carte[k].posy+3, Sprite, 0, m, 8,8)
			carte[k].ImCanTxt1 = Canvas.newText(carte[k].posx+n, carte[k].posy+3, l, coul)
			carte[k].ImCanDes2 = Canvas.newImage(carte[k].posx+20, carte[k].posy+40, Sprite, 0, m, 8,8)
			carte[k].ImCanTxt2 = Canvas.newText(carte[k].posx+3, carte[k].posy+40, l, coul)
			addCarte(k)
		end
	end
end

local retourneCarte = function(num)
	if(carte[num].retour) then
		Canvas.setAttr(carte[num].ImCanvas, ATTR_X2, 8)
		Canvas.setAttr(carte[num].ImCanDes1, ATTR_VISIBLE, true)
		Canvas.setAttr(carte[num].ImCanDes2, ATTR_VISIBLE, true)
		Canvas.setAttr(carte[num].ImCanTxt1, ATTR_VISIBLE, true)
		Canvas.setAttr(carte[num].ImCanTxt2, ATTR_VISIBLE, true)
		carte[num].retour = false
	else
		Canvas.setAttr(carte[num].ImCanvas, ATTR_X2, 38)
		Canvas.setAttr(carte[num].ImCanDes1, ATTR_VISIBLE, false)
		Canvas.setAttr(carte[num].ImCanDes2, ATTR_VISIBLE, false)
		Canvas.setAttr(carte[num].ImCanTxt1, ATTR_VISIBLE, false)
		Canvas.setAttr(carte[num].ImCanTxt2, ATTR_VISIBLE, false)
		carte[num].retour = true
	end
end

local setCarteOnTop = function(num)
	Canvas.setObjOnTop(tapisJeux, carte[num].ImCanvas)
	Canvas.setObjOnTop(tapisJeux, carte[num].ImCanDes1)
	Canvas.setObjOnTop(tapisJeux, carte[num].ImCanDes2)
	Canvas.setObjOnTop(tapisJeux, carte[num].ImCanTxt1)
	Canvas.setObjOnTop(tapisJeux, carte[num].ImCanTxt2)
end

local hideCarte = function(num, cache)
	Canvas.setAttr(carte[num].ImCanvas, ATTR_VISIBLE, not cache)
	Canvas.setAttr(carte[num].ImCanDes1, ATTR_VISIBLE, not cache)
	Canvas.setAttr(carte[num].ImCanDes2, ATTR_VISIBLE, not cache)
	Canvas.setAttr(carte[num].ImCanTxt1, ATTR_VISIBLE, not cache)
	Canvas.setAttr(carte[num].ImCanTxt2, ATTR_VISIBLE, not cache)
end

local moveCarte = function(num, x, y)
	local n
	carte[num].posx = x
	carte[num].posy = y
	if(carte[num].val == 10) then n = 14 else n = 20 end
	Canvas.setAttr(carte[num].ImCanvas, ATTR_X1, x)
	Canvas.setAttr(carte[num].ImCanvas, ATTR_Y1, y)
	Canvas.setAttr(carte[num].ImCanDes1, ATTR_X1, x+3)
	Canvas.setAttr(carte[num].ImCanDes1, ATTR_Y1, y+3)
	Canvas.setAttr(carte[num].ImCanDes2, ATTR_X1, x+20)
	Canvas.setAttr(carte[num].ImCanDes2, ATTR_Y1, y+40)
	Canvas.setAttr(carte[num].ImCanTxt1, ATTR_X1, x+n)
	Canvas.setAttr(carte[num].ImCanTxt1, ATTR_Y1, y+3)
	Canvas.setAttr(carte[num].ImCanTxt2, ATTR_X1, x+3)
	Canvas.setAttr(carte[num].ImCanTxt2, ATTR_Y1, y+40)
end

local melange = function()
	local i, j
	math.randomseed(os.time())
	for i=1, 52 do
		ltalon[i] = 0
		if(not carte[i].retour) then retourneCarte(i) end
	end
	i = 0
	while (i< 48) do
		i = i+1
		repeat
			j = math.random(1,52)
		until(ltalon[j] == 0)
		ltalon[j] = i
		screen.print(SCREEN_UP, 0,0,i) render()
	end
	for i=49, 52 do
		j = 1
		while(ltalon[j] > 0) do
			j = j+1
		end
		ltalon[j] = i
	end
end

local initTer = function()
	local i, j, z
	z = 52
	for i = 1, 7 do
		retourneCarte(ltalon[z])
		for j= i, 7 do
			table.insert(l[j],ltalon[z])
			setCarteOnTop(ltalon[z])
			table.remove(ltalon, z)
			z = z-1
		end
	end
end

local resetCarte = function()
	local i
	for i=1,52 do
		hideCarte(i, false)
		if(carte[i].retour) then retourneCarte(i) end
		moveCarte(i, 1, 2)
	end
	for i=1, 7 do
		while (#l[i] > 0) do
			table.remove(l[i], 1)
		end
	end
	while (#lpioche > 0) do
		table.remove(lpioche, 1)
	end
	while (#ltalon > 0) do
		table.remove(ltalon, 1)
	end
	for i=1,4 do
		tour[i].val = 0
	end
end

local createTapis = function()
	local i, j, k, x, y, dansSel, coul
	for i= 1, 7 do
		for j=1, #l[i] do
			dansSel = false
			for k = 1, #pileSel do
				if(l[i][j] == pileSel[k]) then dansSel = true end
			end
			if(not dansSel) then
				x = (i*32)+1
				y = ((j-1)*10)+2
				moveCarte(l[i][j],x,y)
			end
		end
	end
end

local verifPress = function(x, y)
	local xx, yy, i, j
	if(x>1 and x<31) then
		if(y>2 and y<52 ) then
			if(#ltalon == 0) then -- Talon vide
				j = #lpioche
				for i = j, 2, -1 do
					table.insert(ltalon, lpioche[i])
					retourneCarte(ltalon[#ltalon])
					moveCarte(ltalon[#ltalon], 1, 2)
					setCarteOnTop(ltalon[#ltalon])
					table.remove(lpioche, i)
				end
			else -- Pose une carte dans la pioche depuis le talon
				table.insert(lpioche, ltalon[#ltalon])
				retourneCarte(lpioche[#lpioche])
				moveCarte(lpioche[#lpioche], 1, 60)
				setCarteOnTop(lpioche[#lpioche])
				table.remove(ltalon, #ltalon)
			end
		elseif(y>60 and y<112 ) then -- On selectionne la carte visible de la pioche
			table.insert(pileSel,lpioche[#lpioche])
			if(#pileSel == 1) then
				oldx = carte[lpioche[#lpioche]].posx
				oldy = carte[lpioche[#lpioche]].posy
				setCarteOnTop(pileSel[1])
			end
		end
	elseif(x>33 and x<255) then -- On prends plusieurs cartes
		xx = math.floor((x-33)/32) +1
		yy = math.floor((y-2)/10) +1
		if(l[xx][yy] ~= nil) then
			if(not carte[l[xx][yy]].retour) then
				oldx = carte[l[xx][yy]].posx
				oldy = carte[l[xx][yy]].posy
				for i=yy, #l[xx] do
					table.insert(pileSel, l[xx][i])
					setCarteOnTop(l[xx][i])
				end
			end
		elseif(#l[xx] > 0) then -- On regarde si on a cliquer sur une carte du dessus d'une pile non vide
			if(y>((#l[xx]-1)*10)+2 and y<((#l[xx]-1)*10)+52) then
				oldx = carte[l[xx][#l[xx]]].posx
				oldy = carte[l[xx][#l[xx]]].posy
				table.insert(pileSel, l[xx][#l[xx]])
				setCarteOnTop(l[xx][#l[xx]])
			end
		end
	end
	if(x>1 and x<21) then
		if(y>170 and y<190) then menu = not menu end
	end
end

local stylusHeld = function(x, y)
	local i
	for i=1, #pileSel do
		moveCarte(pileSel[i], x-15, (y-8)+((i-1)*10))
	end
end

local stylusRelease = function(x, y)
	local xx, yy, i, oldxx, oldyy, j
	local reset = true
	xx = math.floor((x-33)/32) +1
	yy = math.floor((y-2)/10) +1
	oldxx = math.floor((oldx-33)/32) +1
	oldyy = math.floor((oldy-2)/10) +1
	if(xx > 0 and xx <8 and #pileSel > 0) then
		if(y>((#l[xx]-1)*10)+2 and y<((#l[xx]-1)*10)+52) then
			if(#l[xx] == 0) then
				reset = false
			else
				if(carte[pileSel[1]].val == carte[l[xx][#l[xx]]].val-1) then
					if(carte[pileSel[1]].coul%2 ~= carte[l[xx][#l[xx]]].coul%2) then
						reset = false
					end
				end
			end
		end
	end
	if(reset) then
		for i=1, #pileSel do
			moveCarte(pileSel[i], oldx, oldy+((i-1)*10))
		end
	else
		for i=1, #pileSel do
			moveCarte(pileSel[i], (xx*32)+1, (#l[xx]*10)+2)
			table.insert(l[xx], pileSel[i])
		end
		if(oldxx < 1) then table.remove(lpioche, #lpioche)
		else
			j = #l[oldxx]
			for i=j, j-(#pileSel-1), -1 do
				table.remove(l[oldxx], i)
			end
			if(#l[oldxx] > 0) then 
				if(carte[l[oldxx][#l[oldxx]]].retour) then
					retourneCarte(l[oldxx][#l[oldxx]]) end
			end
		end
	end
	pileSel = nil
	pileSel = {}
end

local stylusDblClick = function(x, y)
	local xx, yy, i
	local numc = 0
	local col = 0
	local orig = 0
	xx = math.floor((x-33)/32) +1
	yy = math.floor((y-2)/10) +1
	for i=1, 4 do
		if(xx >0 and xx <8) then
			if(y>((#l[xx]-1)*10)+2 and y<((#l[xx]-1)*10)+52 and #l[xx] > 0) then
				if(tour[i].val == 0) then
					if(carte[l[xx][#l[xx]]].val == 1) then
						numc = l[xx][#l[xx]]
						col = i
						table.remove(l[xx],#l[xx])
						if(#l[xx] > 0 and carte[l[xx][#l[xx]]].retour) then retourneCarte(l[xx][#l[xx]]) end
						break
					end
				elseif(carte[l[xx][#l[xx]]].coul == tour[i].coul) then
					if(carte[l[xx][#l[xx]]].val == tour[i].val +1) then
						numc = l[xx][#l[xx]]
						col = i
						table.remove(l[xx],#l[xx])
						if(#l[xx] > 0 and carte[l[xx][#l[xx]]].retour) then retourneCarte(l[xx][#l[xx]]) end
						break
					end
				end
			end
		elseif(x>1 and x<31) then
			if(y>60 and y<110 and #lpioche > 0) then
				if(tour[i].val == 0) then
					if(carte[lpioche[#lpioche]].val == 1) then
						numc = lpioche[#lpioche]
						col = i
						table.remove(lpioche,#lpioche)
						break
					end
				elseif(carte[lpioche[#lpioche]].coul == tour[i].coul) then
					if(carte[lpioche[#lpioche]].val == tour[i].val +1) then
						numc = lpioche[#lpioche]
						col = i
						table.remove(lpioche,#lpioche)
						break
					end
				end
			end
		end
	end
	if(numc > 0) then
		tour[col].val = carte[numc].val
		tour[col].coul = carte[numc].coul
		hideCarte(numc, true)
		if(tour[col].val == 1) then
			j = tour[col].val%13
			k = tour[col].coul
			x = (col-1)*32
			Canvas.add(tapisTour, Canvas.newImage(x, 0, Sprite, 8, 0, 30, 50))
			if(j== 11) then j = "V"
			elseif(j== 12) then j = "D"
			elseif(j== 13) then j = "R" end
			if(k%2 == 1) then coul = coulBlack
			else coul = coulRed end
			if(j == 10) then n = 14 else n = 20 end
			tour[col].Txt1 = Canvas.newText(x+n, 3, j, coul)
			tour[col].Txt2 = Canvas.newText(x+3, 40, j, coul)
			Canvas.add(tapisTour, Canvas.newImage(x+3, 3, Sprite, 0, k*8, 8,8))
			Canvas.add(tapisTour, Canvas.newImage(x+20, 40, Sprite, 0, k*8, 8,8))
			Canvas.add(tapisTour, tour[col].Txt1)
			Canvas.add(tapisTour, tour[col].Txt2)
		else
			j = tour[col].val%13
			x = (col-1)*32
			if(j== 11) then j = "V"
			elseif(j== 12) then j = "D"
			elseif(j== 13) then j = "R" end
			if(j == 10) then n = 14 else n = 20 end
			Canvas.setAttr(tour[col].Txt1, ATTR_TEXT, j)
			Canvas.setAttr(tour[col].Txt1, ATTR_X1, x+n)
			Canvas.setAttr(tour[col].Txt2, ATTR_TEXT, j)
		end
	end
end

local menuJeu = function()
	screen.blit(SCREEN_DOWN, 22, 163, Sprite, 0, 50, 68, 15)
	screen.print(SCREEN_DOWN, 25,167, "Quitter")
	screen.blit(SCREEN_DOWN, 22, 146, Sprite, 0, 50, 68, 15)
	screen.print(SCREEN_DOWN, 25,150, "Distribuer")
	local x = Stylus.X
	local y = Stylus.Y
	if(Stylus.newPress) then
		if(x>1 and x<21) then
			if(y>170 and y<190) then menu = not menu end
		elseif(x>22 and x<90) then
			if(y>163 and y<178) then quit = true
			elseif(y>146 and y<161) then
				resetCarte()
				melange()
				initTer()
				createTapis()
				menu = false
			end
		end
	end
end

if(MICROLUA_VERSION < "4.0.1") then
	while(not Keys.newPress.A) do
		Controls.read()
		screen.print(SCREEN_UP,0,0,"MicroLua Version: "..MICROLUA_VERSION)
		screen.print(SCREEN_DOWN, 0,0, "Ce script ne fonctionne pour le moment que")
		screen.print(SCREEN_DOWN, 0,10, "sur hardware avec microlua 4.0.1 ou supp.")
		screen.print(SCREEN_DOWN, 0, 20, "A pour quitter")
		render()
	end
	quit = true
else
	createCarte()
	melange()
	initTer()
	createTapis()
end

while not quit do
	Controls.read()
	Canvas.draw(SCREEN_DOWN, tapisBas, 0, 0)
	Canvas.draw(SCREEN_UP, tapisHaut, 0, 0)
	Canvas.draw(SCREEN_DOWN, tapisJeux, 0, 0)
	Canvas.draw(SCREEN_UP, tapisTour, 129, 141)
	screen.print(SCREEN_UP,150, 64, "Version :"..V_SOLITAIRE, coulBlack)
	screen.print(SCREEN_UP,80,110,"Double clic ou A+clic sur une")
	screen.print(SCREEN_UP,80,120,"carte pour la ranger dans")
	screen.print(SCREEN_UP,80,130,"l'ordre croissant ci-dessous")
	if(not menu) then
		if(Stylus.newPress and Keys.released.A) then verifPress(Stylus.X, Stylus.Y)
		elseif(Stylus.newPress and Keys.held.A) then stylusDblClick(Stylus.X, Stylus.Y)
		elseif(Stylus.held) then stylusHeld(Stylus.X, Stylus.Y)
		elseif(Stylus.released) then stylusRelease(Stylus.X, Stylus.Y)
		end
		if(Stylus.doubleClick) then stylusDblClick(Stylus.X, Stylus.Y) end
	else
		menuJeu()
	end
	if(tour[1].val == 13 and tour[2].val == 13 and tour[3].val == 13 and tour[4].val == 13) then ok = true end
	if(Keys.newPress.Start) then pause = true end
	render()
end

Canvas.destroy(tapisJeux)
Canvas.destroy(tapisBas)
Canvas.destroy(tapisHaut)
Canvas.destroy(tapisTour)
Image.destroy(Sprite)
Image.destroy(Titre)
